//SHW080926

#include "stdafx.h"
#include "OEM.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////////
BYTE	gbyImg8bit[IMG8BIT_SIZE];
BYTE	gbyImgRaw[320*240];
BYTE	gbyTemplate[FP_TEMPLATE_SIZE];

WORD gwDevID = 1;
WORD gwLastAck = 0;
int  gwLastAckParam = 0;
int  gnPassedTime = 0;

devinfo gDevInfo;

//////////////////////////////////////////////////////////////////////////
int oem_CommandRun(WORD wCmd, int nCmdParam)
{
	if( oemp_SendCmdOrAck( gwDevID, wCmd, nCmdParam ) < 0 )
		return OEM_COMM_ERR;
	gnPassedTime = GetTickCount();
	if( oemp_ReceiveCmdOrAck( gwDevID, &gwLastAck, &gwLastAckParam ) < 0 )
		return OEM_COMM_ERR;
	gnPassedTime = GetTickCount() - gnPassedTime;
	return 0;
}

int oem_open( void )
{
	if (oem_CommandRun( CMD_OPEN, 1 ) < 0 )
		return OEM_COMM_ERR;

	if( oemp_ReceiveData( gwDevID, (BYTE*)&gDevInfo, sizeof(devinfo)) < 0 )
		return OEM_COMM_ERR;

	return 0;
}

int oem_close( void )
{
	return oem_CommandRun( CMD_CLOSE, 0);
}

extern DWORD gCommTimeOut;
int oem_usb_internal_check( void ){
	
	DWORD prevCommTimeOut = gCommTimeOut;
	gCommTimeOut = 1000;
	
	int ret = oem_CommandRun( CMD_USB_INTERNAL_CHECK, gwDevID );
	
	gCommTimeOut = prevCommTimeOut;
	return ret;
}

int oem_change_baudrate( int nBaudrate )
{
	return oem_CommandRun( CMD_CHANGE_BAUDRATE, nBaudrate );
}

int oem_iap_mode( void )
{
	return oem_CommandRun( CMD_IAP_MODE, 0 );
}

int oem_cmos_led( BOOL bOn )
{
	return oem_CommandRun( CMD_CMOS_LED, bOn ? 1 : 0 );
}

int oem_enroll_count( void )
{
	return oem_CommandRun( CMD_ENROLL_COUNT, 0 );
}

int oem_check_enrolled( int nPos )
{
	return oem_CommandRun( CMD_CHECK_ENROLLED, nPos );
}

int oem_enroll_start( int nPos )
{
	return oem_CommandRun( CMD_ENROLL_START, nPos );
}

int oem_enroll_nth( int nTurn, BOOL bGetTemplate )
{
	int ret = oem_CommandRun( CMD_ENROLL_START+nTurn, 0 );
	if (!bGetTemplate || nTurn != 3)
	{
		return ret;
	}
	if( oemp_ReceiveData( gwDevID, &gbyTemplate[0], FP_TEMPLATE_SIZE ) < 0 )
		return OEM_COMM_ERR;
	return ret;
}

int oem_is_press_finger( void )
{
	return oem_CommandRun( CMD_IS_PRESS_FINGER, 0 );
}

int oem_delete( int nPos )
{
	return oem_CommandRun( CMD_DELETE, nPos );
}

int oem_delete_all( void )
{
	return oem_CommandRun( CMD_DELETE_ALL, 0 );
}

int oem_verify( int nPos )
{
	return oem_CommandRun( CMD_VERIFY, nPos );
}

int oem_identify( void )
{
	return oem_CommandRun( CMD_IDENTIFY, 0 );
}

int oem_verify_template( int nPos )
{
	if( oem_CommandRun( CMD_VERIFY_TEMPLATE, nPos ) < 0 )
		return OEM_COMM_ERR;
	
	if(gwLastAck == ACK_OK)
	{
		if( oemp_SendData( gwDevID, &gbyTemplate[0], FP_TEMPLATE_SIZE ) < 0 )
			return OEM_COMM_ERR;
		
		gnPassedTime = GetTickCount();
		if( oemp_ReceiveCmdOrAck( gwDevID, &gwLastAck, &gwLastAckParam ) < 0 )
			return OEM_COMM_ERR;
		gnPassedTime = GetTickCount() - gnPassedTime;
	}
	
	return 0;
}

int oem_identify_template( void )
{
	if( oem_CommandRun( CMD_IDENTIFY_TEMPLATE, 0 ) < 0 )
		return OEM_COMM_ERR;
	
	if(gwLastAck == ACK_OK)
	{
		if( oemp_SendData( gwDevID, &gbyTemplate[0], FP_TEMPLATE_SIZE ) < 0 )
			return OEM_COMM_ERR;
		
		gnPassedTime = GetTickCount();
		if( oemp_ReceiveCmdOrAck( gwDevID, &gwLastAck, &gwLastAckParam ) < 0 )
			return OEM_COMM_ERR;
		gnPassedTime = GetTickCount() - gnPassedTime;
	}
	
	return 0;
}

int oem_capture( BOOL bBest )
{
	return oem_CommandRun( CMD_CAPTURE, bBest );
}

static BYTE	gbyImg256_2[224*200];

int oem_get_image( void )
{
	if( oem_CommandRun( CMD_GET_IMAGE, 0 ) < 0 )
		return OEM_COMM_ERR;
	
	if( oemp_ReceiveData( gwDevID, gbyImg256_2, sizeof gbyImg256_2 ) < 0 )
		return OEM_COMM_ERR;
	
	memset(gbyImg8bit, 161, sizeof(gbyImg8bit));
	int i;
	for (i=0; i<200; i++)
	{
		memcpy(&gbyImg8bit[256*(28 + i) + 16], &gbyImg256_2[i * 224], 224);
	}

	return 0;
}

static BYTE	gbyImgRaw2[256*192];

static void stretch_image()
{
	int i,j,J,j3,i3, x1;
	int	m,m1;
	BYTE *p;

	static BOOL bParam_calced = FALSE;
	static short gICap[320];
	static BYTE  gDeltaI[320];
	
	if (!bParam_calced)
	{
		for( i=0; i < 320; i++)
		{
			m = i * 256 / 320;
			m1 = (i * 256 % 320) * 256 / 320;
			gICap[i] = m;
			gDeltaI[i] = m1;
		}

		bParam_calced = TRUE;
	}
	
	for(i=0;i<240;i++)
	{
		i3 = gICap[i];
		x1 = gDeltaI[i];
		
		for( j=0;j<320;j++)
		{
			j3 = gICap[j];
			J = gDeltaI[j];
			p = (BYTE*)&gbyImgRaw2[0] + i3 * 256 + j3;
			gbyImgRaw[i*320+j]=((*p * (x1-256)-(*(p+256))*x1)*(J-256)
				+((*(p+257))*x1-(*(p+1))*(x1-256))*J)/256/256;	
		}
	}
}

int oem_get_rawimage( void )
{
	if( oem_CommandRun( CMD_GET_RAWIMAGE, 0 ) < 0 )
		return OEM_COMM_ERR;
	
	if( oemp_ReceiveData( gwDevID, gbyImgRaw2, sizeof gbyImgRaw2 ) < 0 )
		return OEM_COMM_ERR;

	stretch_image();

	return 0;
}

int oem_get_template( int nPos )
{
	if( oem_CommandRun( CMD_GET_TEMPLATE, nPos ) < 0 )
		return OEM_COMM_ERR;

	if(gwLastAck == ACK_OK)
	{
		if( oemp_ReceiveData( gwDevID, &gbyTemplate[0], FP_TEMPLATE_SIZE ) < 0 )
			return OEM_COMM_ERR;
	}
	
	return 0;
}

int oem_add_template( int nPos, BOOL bNoDupCheck )
{
	if( oem_CommandRun( CMD_ADD_TEMPLATE, MAKELONG(nPos, bNoDupCheck ? 1:0) ) < 0 )
		return OEM_COMM_ERR;
	
	if(gwLastAck == ACK_OK)
	{
		if( oemp_SendData( gwDevID, &gbyTemplate[0], FP_TEMPLATE_SIZE ) < 0 )
			return OEM_COMM_ERR;
		
		if( oemp_ReceiveCmdOrAck( gwDevID, &gwLastAck, &gwLastAckParam ) < 0 )
			return OEM_COMM_ERR;
	}
	
	return 0;
}

int oem_get_database_end( void ){
	return oem_CommandRun( CMD_GET_DATABASE_END, 0 );
}

int oem_get_database_start( void ){
	return oem_CommandRun( CMD_GET_DATABASE_START, 0 );
}
